# Programming With PLASMA

Welcome to PLASMA, the **P**roto **L**anguage **A**s**S**e**M**bler for **A**pple. PLASMA is an attempt to satisfy a few issues with developing modern programs for the Apple II computer. First, the Apple II is a very constrained system by today's standards - performance and memory limitations drove the architecture of PLASMA. Second, most program building occurs in a cross-development environment nowadays. However, having the ability to code directly on the machine can be a very beneficial prototyping tool. Third, language syntax has evolved somewhat in the past 20 years. Getting a more current language *flavor* keeps the Apple II feeling fresh. Lastly, newer hardware has been developed in the past 10 years that didn't have support in older languages.

This article will take you through the process of building an "internet chat"-style program for the Apple II using PLASMA. The hardware requirements to run the final program include an Apple II with 64K of RAM and an Uthernet or Uthernet II ethernet card. Along the way, there will be plenty of opportunity to play along with an emulator or an Apple II without an ethernet card.

There are a few resources at your disposal to reference if, and when, you have questions. The definitive site to get started is on GitHub[^1]. The README file is the best tutorial and reference manual to get answers.

If you are the hands-on type and need that interactive approach to pick up a new language, then you can install the PLASMA sandbox[^2], an IDE/playground for PLASMA coding, on a real or emulated Apple II.
If you have a fairly powerful computer, you may want to run the terrific Apple II emulator in Javascript by Will Scullin[^3]. Now, you can follow along with the KansasFest 2015 PLASMA talk on YouTube[^4] or the Internet Archive[^5].

[^1]: http://github.com/dschmenk/PLASMA
[^2]: http://github.com/dschmenk/PLASMA/SANDBOX.PO
[^3]: http://www.scullinsteel.com/apple/e
[^4]: http://www.youtube.com/watch?v=RrR79WVHwJo?t=11m24s
[^5]: http://archive.org/details/Kansasfest2015ThePlasmaLanguage
